!======================================================
!file: autoc.f90
!
!Compile with:
!gfortran -O2 getopt.f90 autoc.f90 -o autoc
!======================================================
!Autocorrelation function: you can use this module in
!any of your programs.
MODULE rho_function 
 implicit none
 SAVE
 integer                 :: NMAX,tmax
 character(200)          :: prog
 CONTAINS 
!------------------------------------------------------
!rho is the unnormalized autocorrelation function at t:
  real(8) function rho(x,ndat,t)
   implicit none
   integer               :: ndat,t
   real(8),dimension(0:) :: x
   integer               :: n,t0
   real(8)               :: xav0,xavt,r
!--------------------------------------
   n=ndat-t
   if(n<1) call locerr('rho: n<1')
!Caclulate the two averages: xav0=<x>_0, xavt=<x>_t
   xav0 = SUM( x(0:n-1  )) / n
   xavt = SUM( x(t:n-1+t)) / n
   rho  = SUM((x(0:n-1)-xav0)*(x(t:n-1+t)-xavt))/n
  end function rho
!------------------------------------------------------
  subroutine locerr(errmes)
   implicit none
   character(*) :: errmes
   write(0,'(A,A)')TRIM(prog),':',TRIM(errmes),' Exiting....'
   stop 1
  end subroutine locerr
END MODULE rho_function
!======================================================
program autocorrelations
 USE rho_function
 implicit none
 real(8),allocatable,dimension(:) :: r,tau,x
 real(8)                          :: norm
 integer                          :: i,ndat,t,tcut,chk
!------------------------------------------------------
!Default values for max number of data and max time for
!rho and tau:
 NMAX=2000000;tmax=1000 !NMAX=2e6 requires ~ 2e6*8=16MB 
 call get_the_options
 ALLOCATE(x(0:NMAX-1),STAT=chk)
 if(chk > 0) call locerr('Not enough memory for x')
 ndat=0
 do while ( ndat < NMAX)
  read(*,*,END=101)x(ndat)
  ndat = ndat+1
 enddo ! 
101 continue
 if(ndat >= NMAX) write(0,'(3A,I14,A,I14)')  &
      '# ',TRIM(prog),                       &
      ': Warning: read ndat=', ndat,         &
      ' and reached the limit: ',NMAX
!We decrease tmax if it is comparable or large of ndat
 if(tmax > (ndat/10) ) tmax = ndat/10
!r(t) stores the values of the autocorrelatin function rho(t)
 ALLOCATE(r(0:tmax-1))
 do t=0,tmax-1
  r(t) = rho(x,ndat,t)
 enddo
 norm  = 1.0D0/r(0); r = norm*r
!tau(t) stores integrated autocorrelation times with tcht=t
 ALLOCATE(tau(0:tmax-1))
 do tcut=0,tmax-1
  tau(tcut)=0.0D0
  do t=0,tcut
   tau(tcut) = tau(tcut)+r(t)
  enddo
 enddo
!Output:
 print '(A)','# =========================================================='
 print '(A)','#      Autoc function rho and integrated autoc time tau     '
 print '(A,I12,A,I8)','# ndat= ',ndat,'  tmax= ',tmax
 print '(A)','# t         rho(t)              tau(tcut=t)                 '
 print '(A)','# =========================================================='
 do t=0,tmax-1
  print '(I8,2G28.17)',t,r(t),tau(t)
 enddo
end program autocorrelations
!======================================================
subroutine get_the_options
 use rho_function
 use getopt_m    !from getopt.f90
 implicit none
 call getarg(0,prog)

 do
  select case( getopt( "-ht:n:" ))
  case( 't' )
   read(optarg,*)tmax
  case( 'n' )
   read(optarg,*)NMAX
  case( 'h' )
   call usage
  case( '?' )
   print *, 'unknown option   ', optopt
   stop
  case( char(0)) ! done with options
   exit
  case( '-' )    ! use -- to exit from options
   exit
  case default
   print *, 'unhandled option ', optopt, ' (this is a bug)'
  end select
 enddo

end subroutine get_the_options
!======================================================
subroutine usage
 use rho_function
 implicit none
 print '(3A)','Usage: ',TRIM(prog),'  [-t <maxtime>] [-n <ndata>]'
 print '( A)','      Reads data from stdin (one column) and computes autocorrelation'
 print '( A)','      function and integrated autocorrelation time.'
 stop
end subroutine usage
!======================================================
!  ---------------------------------------------------------------------
!  Copyright by Konstantinos N. Anagnostopoulos (2004-2014)
!  Physics Dept., National Technical University,
!  konstant@mail.ntua.gr, www.physics.ntua.gr/~konstant
!  
!  This program is free software: you can redistribute it and/or modify
!  it under the terms of the GNU General Public License as published by
!  the Free Software Foundation, version 3 of the License.
!  
!  This program is distributed in the hope that it will be useful, but
!  WITHOUT ANY WARRANTY; without even the implied warranty of
!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
!  General Public License for more details.
!  
!  You should have received a copy of the GNU General Public Liense along
!  with this program.  If not, see <http://www.gnu.org/licenses/>.
!  -----------------------------------------------------------------------

!======================================================
!file: histogram.f90
!
!Compile with:
!gfortran -O2 getopt.f90 histogram.f90 -o hist
!======================================================
!histogram function: you can use this module in
!any of your programs.
!------------------------------------------------------
!
MODULE hist_function
 implicit none
 SAVE
 integer                 :: MAXDAT
 real(8)                 :: BINW
 character(200)          :: prog
 CONTAINS
!------------------------------------------------------
!histogram function:
  subroutine histogram(ndat,BINW,nbins,x,xh,h,xmin,xmax)
   integer               :: ndat,nbins
   real(8),dimension(0:) :: x             !careful, array index starts from 0
   real(8),allocatable   :: xh(:)         !histogram and corresponding x-values. arrays start from 0
   integer,allocatable   :: h(:)
   real(8)               :: BINW
   real(8)               :: xmin,xmax
   integer               :: i,ih
!--------------------------------------
! Determine min and max values:
   xmin = HUGE(xmin);xmax = -HUGE(x)
   do i = 0,ndat-1
    if( xmin > x(i) ) xmin = x(i)
    if( xmax < x(i) ) xmax = x(i)
   end do
!--------------------------------------
! Histogram parameters:
   nbins   = (xmax-xmin)/binw+1
   ALLOCATE(h(0:nbins-1));ALLOCATE(xh(0:nbins-1))
   do ih   = 0,nbins-1
    xh(ih) = xmin + ih * BINW + 0.5D0 * BINW  ! place x in the middle of the bin
   end do
! Build Histogram:
   h       = 0;
   do i    = 0, ndat -1
    ih     = (x(i) - xmin )/BINW
    h(ih)  = h(ih) + 1
   end do
  end subroutine histogram
!------------------------------------------------------
  subroutine locerr(errmes)
   implicit none
   character(*) :: errmes
   write(0,'(A,A)')TRIM(prog),':',TRIM(errmes),' Exiting....'
   stop 1
  end subroutine locerr
 END MODULE hist_function
!======================================================
program histogram_program
 use hist_function
 implicit none
 integer             :: ndat,chk,nbins
 real(8),allocatable :: x(:),xh(:)
 integer,allocatable :: h(:)
 real(8)             :: xmin,xmax
 integer             :: ih
 MAXDAT=1000000;BINW=1.0D0
 call get_the_options
 ALLOCATE(x(0:MAXDAT-1),STAT=chk)
 if(chk > 0) call locerr('Not enough memory for x')
 ndat=0
 do while ( ndat < MAXDAT)
  read(*,*,END=101)x(ndat)
  ndat = ndat+1
 enddo
101 continue
 if(ndat >= MAXDAT) write(0,'(3A,I14,A,I14)') &
      '# ',TRIM(prog),                        &
      ': Warning: read ndat=', ndat,          &
      ' and reached the limit: ',MAXDAT
 call histogram(ndat,BINW,nbins,x,xh,h,xmin,xmax)
 print '(A)',"# ########################################################################"
 print '(A)',"# Histogram:"
 print '(A,I20,A,I10,A,G10.3)',"# ndat= ",ndat," nbins= ",nbins," binw= ",BINW
 print '(A)',"# x:   data value"
 print '(A)',"# H:   no .data in [x-BINW/2,x+BINW/2]"
 print '(A)',"# h:   relative frequency H/ndat"
 print '(A)',"# rho: normalized data s.t. int_0^infty rho(x) dx = 1"
 print '(A)',"# x     Η       h        rho"
 print '(A)',"# ------------------------------------------------------------------------"
 do ih = 0 , nbins - 1
  if(h(ih) > 0 )then
   print '(4G28.16)',xh(ih),h(ih),DBLE(h(ih))/ndat,DBLE(h(ih))/ndat/BINW
  end if
 end do
end program histogram_program
!======================================================
subroutine get_the_options
 use hist_function
 use getopt_m    !from getopt.f90
 implicit none
 call getarg(0,prog)

 do
  select case( getopt( "-hb:d:" ))
  case( 'b' )
   read(optarg,*)BINW
  case( 'd' )
   read(optarg,*)MAXDAT
  case( 'h' )
   call usage
  case( '?' )
   print *, 'unknown option   ', optopt
   stop
  case( char(0)) ! done with options
   exit
  case( '-' )    ! use -- to exit from options
   exit
  case default
   print *, 'unhandled option ', optopt, ' (this is a bug)'
  end select
 enddo

end subroutine get_the_options
!=============================================
subroutine usage
 use hist_function
 implicit none
 print '(3A    )','Usage: ',TRIM(prog),'  [options]'
 print '( A    )','       -b  : Bin width Def. 1'
 print '( A,I14)','       -d  : Give the maximum number of data points read.Def. ',MAXDAT
 print '( A)','Computes histogram of data. Output is x,h(x),h(x)/ndat,f(x)=h(x)/ndat/BINW'
 print '( A)','Data is in one column from stdin.'
 stop
end subroutine usage

!  ---------------------------------------------------------------------
!  Copyright by Konstantinos N. Anagnostopoulos (2004-2014)
!  Physics Dept., National Technical University,
!  konstant@mail.ntua.gr, www.physics.ntua.gr/~konstant
!  
!  This program is free software: you can redistribute it and/or modify
!  it under the terms of the GNU General Public License as published by
!  the Free Software Foundation, version 3 of the License.
!  
!  This program is distributed in the hope that it will be useful, but
!  WITHOUT ANY WARRANTY; without even the implied warranty of
!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
!  General Public License for more details.
!  
!  You should have received a copy of the GNU General Public Liense along
!  with this program.  If not, see <http://www.gnu.org/licenses/>.
!  -----------------------------------------------------------------------

!======================================================
!file: boot_bin.f90
!
!Compile with:
!gfortran -O2 getopt.f90 boot_bin.f90 -o boot_bin
!======================================================
!bootstrap function: you can use this module in
!any of your programs.
!------------------------------------------------------
!                Jackknife binning
!                -----------------
!. Separates the data in BINS jackknife bins
!. For each bin collects SAMPLES bootstrap measurements:
!     + Picks ndat-binw random values from each bin
!     + The average O,O^2, and computed chi is the value of one sample
!. The samples of each bin are averaged to give the value of each jackknife bin
!. Bins are averaged and jackknife errors calculated
!Gives correct results. For 100000 data for |M|, error is
!independent of number of bins for BINS=5, ..., 1000
!(Ising 2d data, L=12, beta=0.36, tau_autoc ~ 8)
!------------------------------------------------------
MODULE bootbin_function
 implicit none
 SAVE
 integer                 :: SAMPLES,MAXDAT,BINS
 character(200)          :: prog
 integer                 :: seed
 CONTAINS
!------------------------------------------------------
!jackknife function:
  subroutine bootstrap(ndat,samples,bins,x,&
       avO,erO,avchi,erchi)
   integer               :: ndat,samples,bins
   real(8),dimension(0:) :: x
   real(8)               :: avO,erO,avchi,erchi,av0all
   integer               :: i,j,k,m,n,b,binw,ndat_in_bin
   real(8),allocatable   :: O(:),O2(:),chi(:),Ob(:),chib(:)
!--------------------------------------
!compute the real average:
   av0all       = SUM(x(0:ndat-1))/ndat
!Number of data in each bin
   binw         = ndat/bins;
   ndat_in_bin  = ndat - binw;
   ALLOCATE(O (0:samples-1));ALLOCATE(O2 (0:samples-1));ALLOCATE(chi(0:samples-1));
   ALLOCATE(Ob(0:bins   -1));ALLOCATE(chib(0:bins   -1));
   Ob     =   0.0D0; chib = 0.0D0;
   O=0.0D0;O2=0.0D0; chi  = 0.0D0;
   do   i = 0,bins-1
    !For each jackknife bin we collect samples samples
    do  j = 0,samples-1
     O(j) = 0.0D0;O2(j) = 0.0D0;
     !Each samples consist of ndat_in_bin "measurements"
     m    = 0
     do while(m<ndat_in_bin)
      k=INT(ndat*drandom())
      if((k/binw) /= i)then   !if k not in the i_th bin, consider the data: 
       O (j) = O (j)   + x(k) !(lazy, improve with computing without wasting)
       O2(j) = O2(j)   + x(k)*x(k)
       m     = m       + 1
      end if
     end do !do while(m<ndat_in_bin)
     !O,O2,chi are the result of each sample
     O   (j)= O   (j) / ndat_in_bin
     O2  (j)= O2  (j) / ndat_in_bin
     chi (j)= O2  (j) - O(j)*O(j)
     !Ob,chib are the jackknife measurements:
     Ob  (i)= Ob  (i) + O(j)
     chib(i)= chib(i) + chi(j)
    end do !j=0,samples-1
    Ob   (i)= Ob  (i) / samples
    chib (i)= chib(i) / samples
   end do  !i=0,bins-1
   !Compute jackknif averages:
   avO    = SUM(Ob  ) / bins
   avchi  = SUM(chib) / bins
   !Compute jackknif errors:
   erO    = sqrt(SUM((Ob  -avO  )*(Ob  -avO  )))
   erchi  = sqrt(SUM((chib-avchi)*(chib-avchi)))
!compute the real avO:
   avO    = av0all
!---------------
   DEALLOCATE(O );DEALLOCATE(O2  );DEALLOCATE(chi)
   DEALLOCATE(Ob);DEALLOCATE(chib)
  end subroutine bootstrap
!------------------------------------------------------
  real(8) function drandom()
   implicit none
   integer,parameter :: a = 16807      ! a = 7**5
   integer,parameter :: m = 2147483647 ! m = a*q+r   = 2**31-1
   integer,parameter :: q = 127773     ! q = [m/a]
   integer,parameter :: r = 2836       ! r = MOD(m,a)
   real(8),parameter :: f = (1.0D0/m)
   integer           :: p
   real(8)           :: dr
101 continue
   p       = seed/q              !  = [seed/q]
   seed    = a*(seed- q*p) - r*p !  = a*MOD(seed,q)-r*[seed/q] = MOD(a*seed,m)
   if(seed .lt. 0) seed = seed + m
   dr      = f*seed
   if( dr .le. 0.0D0 .or. dr .ge. 1.0D0) goto 101
   drandom = dr
  end function drandom
!------------------------------------------------------
  subroutine locerr(errmes)
   implicit none
   character(*) :: errmes
   write(0,'(A,A)') TRIM(prog),':',TRIM(errmes),' Exiting....'
   stop 1
  end subroutine locerr
END MODULE bootbin_function
!======================================================
program bootstrap_errors
 use bootbin_function
 implicit none
 integer             :: ndat,chk
 real(8)             :: O,dO,chi,dchi
 real(8),allocatable :: x(:)
 MAXDAT=1000000;SAMPLES=1000;BINS=20
 call get_the_options
 ALLOCATE(x(0:MAXDAT-1),STAT=chk)
 if(chk > 0) call locerr('Not enough memory for x')
 ndat=0
 do while ( ndat < MAXDAT)
  read(*,*,END=101)x(ndat)
  ndat = ndat+1
 enddo
101 continue
 if(ndat >= MAXDAT) write(0,'(3A,I14,A,I14)') &
      '# ',TRIM(prog),                        &
      ': Warning: read ndat=', ndat,          &
      ' and reached the limit: ',MAXDAT
 open (28, file="/dev/urandom", access="stream", form="unformatted")
 read (28) seed
 seed = ABS(seed)
 close(28)
 call bootstrap(ndat,SAMPLES,BINS,x,O,dO,chi,dchi)
 print '(A,I14,A,I12,A)','#  NDAT = ',ndat,' data. SAMPLES = ',SAMPLES,' groups'
 print '(A,I14        )','#  BINS = ',BINS
 print '(A)','# <o>, chi= (<o^2>-<o>^2)'
 print '(A)','# <o> +/- err                             chi +/- err'
 print '(4G28.17)',O,dO,chi,dchi
end program bootstrap_errors
!======================================================
subroutine get_the_options
 use bootbin_function
 use getopt_m    !from getopt.f90
 implicit none
 call getarg(0,prog)

 do
  select case( getopt( "-hs:d:b:" ))
  case( 's' )
   read(optarg,*)SAMPLES
  case( 'b' )
   read(optarg,*)BINS
  case( 'd' )
   read(optarg,*)MAXDAT
  case( 'h' )
   call usage
  case( '?' )
   print *, 'unknown option   ', optopt
   stop
  case( char(0)) ! done with options
   exit
  case( '-' )    ! use -- to exit from options
   exit
  case default
   print *, 'unhandled option ', optopt, ' (this is a bug)'
  end select
 enddo

end subroutine get_the_options
!=============================================
subroutine usage
 use bootbin_function
 implicit none
 print '(3A)','Usage: ',TRIM(prog),'  [options]'
 print '( A)','       -s  : No. samples Def. 1000'
 print '( A)','       -b  : No. bins. Samples have size ndata/BINS. Def. 20'
 print '( A,I14)','       -d  : Give the maximum number of data points read.Def. ',MAXDAT
 print '( A)','Computes <o>, chi= (<o^2>-<o>^2)'
 print '( A)','Data is in one column from stdin.'
 print '( A)','---------------------------------'
 print '( A)','Jackknife binning: Separates the data in BINS bins of binw=ndat/BINS.' 
 print '( A)','BINS Jackknife bins with ndat-binw data are constructed.'
 print '( A)','For each bin collects SAMPLES bootstrap measurements. Each measurement consists of ndat-binw random values'
 print '( A)','from each jackknife bin.In the end, the SAMPLES measurements are averaged giving the result for each bin.'
 print '( A)','Then this is jackknife-averaged and jackknife errors are computed.'
 stop
end subroutine usage
!=============================================




!  ---------------------------------------------------------------------
!  Copyright by Konstantinos N. Anagnostopoulos (2004-2014)
!  Physics Dept., National Technical University,
!  konstant@mail.ntua.gr, www.physics.ntua.gr/~konstant
!  
!  This program is free software: you can redistribute it and/or modify
!  it under the terms of the GNU General Public License as published by
!  the Free Software Foundation, version 3 of the License.
!  
!  This program is distributed in the hope that it will be useful, but
!  WITHOUT ANY WARRANTY; without even the implied warranty of
!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
!  General Public License for more details.
!  
!  You should have received a copy of the GNU General Public Liense along
!  with this program.  If not, see <http://www.gnu.org/licenses/>.
!  -----------------------------------------------------------------------

! ------------------------------------------------------------
! Copyright 2008 by Mark Gates
!
! This program is free software; you can redistribute or modify it under
! the terms of the GNU general public license (GPL), version 2 or later.
!
! This program is distributed in the hope that it will be useful, but
! WITHOUT ANY WARRANTY; without even the implied warranty of
! merchantability or fitness for a particular purpose.
!
! If you wish to incorporate this into non-GPL software, please contact
! me regarding licensing terms.
!
! ------------------------------------------------------------
! Fortran 95 getopt() and getopt_long(), similar to those in standard C library.
!
! ch = getopt( optstring, [longopts] )
! Returns next option character from command line arguments.
! If an option is not recognized, it returns '?'.
! If no options are left, it returns a null character, char(0).
!
! optstring contains characters that are recognized as options.
! If a character is followed by a colon, then it takes a required argument.
! For example, "x" recognizes "-x", while "x:" recognizes "-x arg" or "-xarg".
!
! optopt is set to the option character, even if it isn't recognized.
! optarg is set to the option's argument.
! optind has the index of the next argument to process. Initially optind=1.
! Errors are printed by default. Set opterr=.false. to suppress them.
!
! Grouped options are allowed, so "-abc" is the same as "-a -b -c".
!
! If longopts is present, it is an array of type(option_s), where each entry
! describes one long option.
!
!    type option_s
!        character(len=80) :: name
!        logical           :: has_arg
!        character         :: val
!    end type
!
! The name field is the option name, without the leading -- double dash.
! Set the has_arg field to true if it requires an argument, false if not.
! The val field is returned. Typically this is set to the corresponding short
! option, so short and long options can be processed together. (But there
! is no requirement that every long option has a short option, or vice-versa.)
!
! -----
! EXAMPLE
! program test
!     use getopt_m
!     implicit none
!     character:: ch
!     type(option_s):: opts(2)
!     opts(1) = option_s( "alpha", .false., 'a' )
!     opts(2) = option_s( "beta",  .true.,  'b' )
!     do
!         select case( getopt( "ab:c", opts ))
!             case( char(0))
!                 exit
!             case( 'a' )
!                 print *, 'option alpha/a'
!             case( 'b' )
!                 print *, 'option beta/b=', optarg
!             case( '?' )
!                 print *, 'unknown option ', optopt
!                 stop
!             case default
!                 print *, 'unhandled option ', optopt, ' (this is a bug)'
!         end select
!     end do
! end program test
!
! Differences from C version:
! - when options are finished, C version returns -1 instead of char(0),
!   and thus stupidly requires an int instead of a char.
! - does not support optreset
! - does not support "--" as last argument
! - if no argument, optarg is blank, not NULL
! - argc and argv are implicit
!
! Differences for long options:
! - optional argument to getopt(), rather than separate function getopt_long()
! - has_arg is logical, and does not support optional_argument
! - does not support flag field (and thus always returns val)
! - does not support longindex
! - does not support "--opt=value" syntax, only "--opt value"
! - knows the length of longopts, so does not need an empty last record

module getopt_m
  implicit none
  character(len=80):: optarg
  character:: optopt
  integer:: optind=1
  logical:: opterr=.true.

  type option_s
     character(len=80) :: name
     logical           :: has_arg
     character         :: val
  end type option_s

  ! grpind is index of next option within group; always >= 2
  integer, private:: grpind=2

contains

  ! ----------------------------------------
  ! Return str(i:j) if 1 <= i <= j <= len(str),
  ! else return empty string.
  ! This is needed because Fortran standard allows but doesn't *require* short-circuited
  ! logical AND and OR operators. So this sometimes fails:
  !     if ( i < len(str) .and. str(i+1:i+1) == ':' ) then
  ! but this works:
  !     if ( substr(str, i+1, i+1) == ':' ) then

  character function substr( str, i, j )
    ! arguments
    character(len=*), intent(in):: str
    integer, intent(in):: i, j

    if ( 1 <= i .and. i <= j .and. j <= len(str)) then
       substr = str(i:j)
    else
       substr = ''
    endif
  end function substr


  ! ----------------------------------------
  character function getopt( optstring, longopts )
    ! arguments
    character(len=*), intent(in):: optstring
    type(option_s),   intent(in), optional:: longopts(:)

    ! local variables
    character(len=80):: arg

    optarg = ''
    if ( optind > iargc()) then
       getopt = char(0)
    endif

    call getarg( optind, arg )
    if ( present( longopts ) .and. arg(1:2) == '--' ) then
       getopt = process_long( longopts, arg )
    elseif ( arg(1:1) == '-' ) then
       getopt = process_short( optstring, arg )
    else
       getopt = char(0)
    endif
  end function getopt


  ! ----------------------------------------
  character function process_long( longopts, arg )
    ! arguments
    type(option_s),   intent(in):: longopts(:)
    character(len=*), intent(in):: arg

    ! local variables
    integer:: i

    ! search for matching long option
    optind = optind + 1
    do i = 1, size(longopts)
       if ( arg(3:) == longopts(i)%name ) then
          optopt = longopts(i)%val
          process_long = optopt
          if ( longopts(i)%has_arg ) then
             if ( optind <= iargc()) then
                call getarg( optind, optarg )
                optind = optind + 1
             elseif ( opterr ) then
                print '(a,a,a)', "Error: option '", trim(arg), "' requires an argument"
             endif
          endif
          return
       endif
    end do
    ! else not found
    process_long = '?'
    if ( opterr ) then
       print '(a,a,a)', "Error: unrecognized option '", trim(arg), "'"
    endif
  end function process_long


  ! ----------------------------------------
  character function process_short( optstring, arg )
    ! arguments
    character(len=*), intent(in):: optstring, arg

    ! local variables
    integer:: i, arglen

    arglen = len( trim( arg ))
    optopt = arg(grpind:grpind)
    process_short = optopt

    i = index( optstring, optopt )
    if ( i == 0 ) then
       ! unrecognized option
       process_short = '?'
       if ( opterr ) then
          print '(a,a,a)', "Error: unrecognized option '-", optopt, "'"
       endif
    endif
    if ( i > 0 .and. substr( optstring, i+1, i+1 ) == ':' ) then
       ! required argument
       optind = optind + 1
       if ( arglen > grpind ) then
          ! -xarg, return remainder of arg
          optarg = arg(grpind+1:arglen)
       elseif ( optind <= iargc()) then
          ! -x arg, return next arg
          call getarg( optind, optarg )
          optind = optind + 1
       elseif ( opterr ) then
          print '(a,a,a)', "Error: option '-", optopt, "' requires an argument"
       endif
       grpind = 2
    elseif ( arglen > grpind ) then
       ! no argument (or unrecognized), go to next option in argument (-xyz)
       grpind = grpind + 1
    else
       ! no argument (or unrecognized), go to next argument
       grpind = 2
       optind = optind + 1
    endif
  end function process_short

end module getopt_m
!  ---------------------------------------------------------------------
!  Copyright by Konstantinos N. Anagnostopoulos (2004-2014)
!  Physics Dept., National Technical University,
!  konstant@mail.ntua.gr, www.physics.ntua.gr/~konstant
!  
!  This program is free software: you can redistribute it and/or modify
!  it under the terms of the GNU General Public License as published by
!  the Free Software Foundation, version 3 of the License.
!  
!  This program is distributed in the hope that it will be useful, but
!  WITHOUT ANY WARRANTY; without even the implied warranty of
!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
!  General Public License for more details.
!  
!  You should have received a copy of the GNU General Public Liense along
!  with this program.  If not, see <http://www.gnu.org/licenses/>.
!  -----------------------------------------------------------------------

!======================================================
!file: boot.f90
!
!Compile with:
!gfortran -O2 getopt.f90 boot.f90 -o boot
!======================================================
!bootstrap function: you can use this module in
!any of your programs.
MODULE boot_function
 implicit none
 SAVE
 integer                 :: SAMPLES,MAXDAT
 character(200)          :: prog
 integer                 :: seed
 CONTAINS
!------------------------------------------------------
!jackknife function:
  subroutine bootstrap(ndat,samples,x,&
       avO,erO,avchi,erchi)
   integer               :: ndat,samples !local samples...
   real(8),dimension(0:) :: x
   real(8)               :: avO,erO,avchi,erchi
   integer               :: i,j,k
   real(8),allocatable   :: O(:),O2(:),chi(:)
!--------------------------------------
   ALLOCATE(O(0:samples-1));ALLOCATE(O2(0:samples-1));ALLOCATE(chi(0:samples-1))
   O=0.0D0;O2=0.0D0;chi=0.0D0;
   do  j=0,samples-1
    do i=0,ndat   -1
     k  = INT(ndat*drandom()) !0,...,ndat-1
     O (j) = O (j) + x(k)
     O2(j) = O2(j) + x(k)*x(k)
    enddo
    O  (j) = O(j)/ndat; O2(j) = O2(j)/ndat
    chi(j) = O2(j)-O(j)*O(j)
   enddo
!---------------
   avO   = SUM(O)/samples;avchi=SUM(chi)/samples
   erO   = sqrt(SUM((O  -avO  )*(O  -avO  ))/samples)
   erchi = sqrt(SUM((chi-avchi)*(chi-avchi))/samples)
!compute the real avO:
   avO   = SUM(x(0:ndat-1))/ndat
!---------------
   DEALLOCATE(O);DEALLOCATE(chi)
  end subroutine bootstrap
!------------------------------------------------------
  real(8) function drandom()
   implicit none
   integer,parameter :: a = 16807      ! a = 7**5
   integer,parameter :: m = 2147483647 ! m = a*q+r   = 2**31-1
   integer,parameter :: q = 127773     ! q = [m/a]
   integer,parameter :: r = 2836       ! r = MOD(m,a)
   real(8),parameter :: f = (1.0D0/m)
   integer           :: p
   real(8)           :: dr
101 continue
   p       = seed/q              !  = [seed/q]
   seed    = a*(seed- q*p) - r*p !  = a*MOD(seed,q)-r*[seed/q] = MOD(a*seed,m)
   if(seed .lt. 0) seed = seed + m
   dr      = f*seed
   if( dr .le. 0.0D0 .or. dr .ge. 1.0D0) goto 101
   drandom = dr
  end function drandom
!------------------------------------------------------
  subroutine locerr(errmes)
   implicit none
   character(*) :: errmes
   write(0,'(A,A)')TRIM(prog),':',TRIM(errmes),' Exiting....'
   stop 1
  end subroutine locerr
END MODULE boot_function
!======================================================
program bootstrap_errors
 use boot_function
 implicit none
 integer             :: ndat,chk
 real(8)             :: O,dO,chi,dchi
 real(8),allocatable :: x(:)
 MAXDAT=1000000;SAMPLES=1000
 call get_the_options
 ALLOCATE(x(0:MAXDAT-1),STAT=chk)
 if(chk > 0) call locerr('Not enough memory for x')
 ndat=0
 do while ( ndat < MAXDAT)
  read(*,*,END=101)x(ndat)
  ndat = ndat+1
 enddo
101 continue
 if(ndat >= MAXDAT) write(0,'(3A,I14,A,I14)') &
      '# ',TRIM(prog),                        &
      ': Warning: read ndat=', ndat,          &
      ' and reached the limit: ',MAXDAT
 open (28, file="/dev/urandom", access="stream", form="unformatted")
 read (28) seed
 seed = ABS(seed)
 close(28)
 call bootstrap(ndat,SAMPLES,x,O,dO,chi,dchi)
 print '(A,I14,A,I12,A)','#  NDAT = ',ndat,' data. SAMPLES = ',SAMPLES,' groups'
 print '(A)','# <o>, chi= (<o^2>-<o>^2)'
 print '(A)','# <o> +/- err                             chi +/- err'
 print '(4G28.17)',O,dO,chi,dchi
end program bootstrap_errors
!======================================================
subroutine get_the_options
 use boot_function
 use getopt_m    !from getopt.f90
 implicit none
 call getarg(0,prog)

 do
  select case( getopt( "-hs:d:" ))
  case( 's' )
   read(optarg,*)SAMPLES
  case( 'd' )
   read(optarg,*)MAXDAT
  case( 'h' )
   call usage
  case( '?' )
   print *, 'unknown option   ', optopt
   stop
  case( char(0)) ! done with options
   exit
  case( '-' )    ! use -- to exit from options
   exit
  case default
   print *, 'unhandled option ', optopt, ' (this is a bug)'
  end select
 enddo

end subroutine get_the_options
!=============================================
subroutine usage
 use boot_function
 implicit none
 print '(3A)','Usage: ',TRIM(prog),'  [options]'
 print '( A)','       -s  : No. samples Def. 1000'
 print '( A,I14)','       -d  : Give the maximum number of data points read.Def. ',MAXDAT
 print '( A)','Computes <o>, chi= (<o^2>-<o>^2)'
 print '( A)','Data is in one column from stdin.'
 stop
end subroutine usage
!=============================================




!  ---------------------------------------------------------------------
!  Copyright by Konstantinos N. Anagnostopoulos (2004-2014)
!  Physics Dept., National Technical University,
!  konstant@mail.ntua.gr, www.physics.ntua.gr/~konstant
!  
!  This program is free software: you can redistribute it and/or modify
!  it under the terms of the GNU General Public License as published by
!  the Free Software Foundation, version 3 of the License.
!  
!  This program is distributed in the hope that it will be useful, but
!  WITHOUT ANY WARRANTY; without even the implied warranty of
!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
!  General Public License for more details.
!  
!  You should have received a copy of the GNU General Public Liense along
!  with this program.  If not, see <http://www.gnu.org/licenses/>.
!  -----------------------------------------------------------------------

!===============================================================================
! Program that reads lines of a file disregarding the ones that contain
! the character '#'
!===============================================================================
program filter_hash
 implicit none
 integer :: E,M,eof
 character(10000) :: line

 open(unit=11,file='test')
 do
  read(11,'(A10000)',IOSTAT=eof) line   !read a line as a string
  if(eof /= 0) exit                     !reached end of file
  if(INDEX(line,'#') == 0)then          !if there are no # in line, then process
   read(line,*) E,M
   print *,E,M
  endif
 enddo


end program filter_hash

!======================================================
!file: jack.f90
!
!Compile with:
!gfortran -O2 getopt.f90 jack.f90 -o jack
!======================================================
!jackknife function: you can use this module in
!any of your programs.
!------------------------------------------------------
!Note: If ndat % jack != 0, then the algorithm works fine.
!      Each bin has ndat-binw data, bins never cross
!      remainder of data (i >= (jack*binw))
MODULE jack_function
 implicit none
 SAVE
 integer                 :: JACK,MAXDAT
 character(200)          :: prog
 CONTAINS
!------------------------------------------------------
!jackknife function:
  subroutine jackknife(ndat,jack,x,&
       avO,erO,avchi,erchi)
   integer               :: ndat,jack !local jack...
   real(8),dimension(0:) :: x
   real(8)               :: avO,erO,avchi,erchi
   integer               :: i,j,binw,bin
   real(8),allocatable   :: O(:),chi(:)
!--------------------------------------
   ALLOCATE(O(0:jack-1));ALLOCATE(chi(0:jack-1))
   O=0.0D0;chi=0.0D0;
   binw=ndat/jack
   if(binw<1)call locerr('jackknife: binw < 1')
!Average value:
   do i=0,ndat-1
    do j=0,jack-1
     if((i/binw) /= j) &
          O  (j) = O  (j) + x(i)
    enddo
   enddo
   O   = O  /(ndat-binw) !normalize
!Susceptibility:
   do i=0,ndat-1
    do j=0,jack-1
     if((i/binw) /= j) &
          chi(j) = chi(j) + (x(i)-O(j))*(x(i)-O(j)) 
    enddo
   enddo
   chi   = chi/(ndat-binw) !normalize
!---------------
   avO   = SUM(O)/jack;avchi=SUM(chi)/jack
   erO   = sqrt(SUM((O  -avO  )*(O  -avO  )))
   erchi = sqrt(SUM((chi-avchi)*(chi-avchi)))
!---------------
   DEALLOCATE(O);DEALLOCATE(chi)
  end subroutine jackknife
!------------------------------------------------------
  subroutine locerr(errmes)
   implicit none
   character(*) :: errmes
   write(0,'(A,A)')TRIM(prog),':',TRIM(errmes),' Exiting....'
   stop 1
  end subroutine locerr
END MODULE jack_function
!======================================================
program jackknife_errors
 use jack_function
 implicit none
 integer             :: ndat,chk
 real(8)             :: O,dO,chi,dchi
 real(8),allocatable :: x(:)
 MAXDAT=1000000;JACK=10
 call get_the_options
 ALLOCATE(x(0:MAXDAT-1),STAT=chk)
 if(chk > 0) call locerr('Not enough memory for x')
 ndat=0
 do while ( ndat < MAXDAT)
  read(*,*,END=101)x(ndat)
  ndat = ndat+1
 enddo
101 continue
 if(ndat >= MAXDAT) write(0,'(3A,I14,A,I14)') &
      '# ',TRIM(prog),                        &
      ': Warning: read ndat=', ndat,          &
      ' and reached the limit: ',MAXDAT
 call jackknife(ndat,JACK,x,O,dO,chi,dchi)
 print '(A,I14,A,I12,A)','#  NDAT = ',ndat,' data. JACK = ',JACK,' groups'
 print '(A)','# <o>, chi= (<o^2>-<o>^2)'
 print '(A)','# <o> +/- err                             chi +/- err'
 print '(4G28.17)',O,dO,chi,dchi
end program jackknife_errors
!======================================================
subroutine get_the_options
 use jack_function
 use getopt_m    !from getopt.f90
 implicit none
 call getarg(0,prog)

 do
  select case( getopt( "-hj:d:" ))
  case( 'j' )
   read(optarg,*)JACK
  case( 'd' )
   read(optarg,*)MAXDAT
  case( 'h' )
   call usage
  case( '?' )
   print *, 'unknown option   ', optopt
   stop
  case( char(0)) ! done with options
   exit
  case( '-' )    ! use -- to exit from options
   exit
  case default
   print *, 'unhandled option ', optopt, ' (this is a bug)'
  end select
 enddo

end subroutine get_the_options
!=============================================
subroutine usage
 use jack_function
 implicit none
 print '(3A)','Usage: ',TRIM(prog),'  [options]'
 print '( A)','       -j  : No. jack groups Def. 10'
 print '( A,I14)','       -d  : Give the maximum number of data points read.Def. ',MAXDAT
 print '( A)','Computes <o>, chi= (<o^2>-<o>^2)'
 print '( A)','Data is in one column from stdin.'
 stop
end subroutine usage

!  ---------------------------------------------------------------------
!  Copyright by Konstantinos N. Anagnostopoulos (2004-2014)
!  Physics Dept., National Technical University,
!  konstant@mail.ntua.gr, www.physics.ntua.gr/~konstant
!  
!  This program is free software: you can redistribute it and/or modify
!  it under the terms of the GNU General Public License as published by
!  the Free Software Foundation, version 3 of the License.
!  
!  This program is distributed in the hope that it will be useful, but
!  WITHOUT ANY WARRANTY; without even the implied warranty of
!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
!  General Public License for more details.
!  
!  You should have received a copy of the GNU General Public Liense along
!  with this program.  If not, see <http://www.gnu.org/licenses/>.
!  -----------------------------------------------------------------------
